function Bullet(pX,pY,pMag,pVX,pVY){
	var b = new Lynx.GameObject("bullet_"+pVX+"_"+pVY+"_"+pMag,pX,pY,5,5);

	var mag = pMag,
		vX = pVX,
		vY = pVY,
		speed = 5,
		damage = 1,
		from = null,
		hit = false,
		fillColor = "#ff33cc"; //Enemy bullet

	b.SetCollisions(true);

	b.onDestroy = function(){};

	b.oncollision = function(pEvent){
		if(hit){
			pEvent.resolved = true;
			return;
		}
		var co = pEvent.collidingObject;
		if(co.GetName() == from.GetName()){ //To not kill originatin object
			pEvent.resolved = true;
			return;
		}
		if(typeof co.GetFaction == 'undefined'){ //In event of powerup object
			pEvent.resolved = true;
			return;
		}
		if(co.GetFaction() == from.GetFaction()){
			pEvent.resolved = true;
		}else{
			co.Hurt(damage)
			pEvent.resolved = true;
			hit = true;
		}
	};


	b.Draw = function(scene){
		if(!hit){
			scene.GetCanvas().GetContext().fillStyle = fillColor;
			scene.GetCanvas().GetContext().fillRect(this.GetX(),this.GetY(),this.GetWidth(),this.GetHeight());
		}
	};

	b.SetSpeed = function(pSpeed){
		speed = pSpeed;
	};

	b.SetDamage = function(pDamage){
		damage = pDamage;
	};

	b.SetFillColor = function(pColor){
		fillColor = pColor;
	};

	b.SetFrom = function(pObject){
		from = pObject;
		damage = pObject.GetDamage();
		fillColor = pObject.GetBulletColor();
		this.GetCollidingObject().SetWidth(pObject.GetBulletSize());
		this.GetCollidingObject().SetHeight(pObject.GetBulletSize());
	};

	b.Update = function(){
		this.SetX((this.GetX()+(speed/mag)*vX));
		this.SetY((this.GetY()+(speed/mag)*vY));
		if(this.GetX() > window.innerWidth || this.GetY() > window.innerHeight || this.GetX() < 0 || this.GetY() < 0 || hit){
			this.onDestroy();
			Lynx.Game.GetCurrentScene().RemoveObject(Lynx.Game.GetCurrentScene().GetIndex(this));
		}
	};

	return b;
};