function Entity(pRef,pX,pY,pWidth,pHeight){
	var e = new Lynx.GameObject(pRef,pX,pY,pWidth,pHeight);
	
	var health = 1,
		mana = Lynx.Constants.STARTING_MANA,
		maxMana = 100,
		damage = 1,
		maxDamage = 99,
		lastShot = 0,
		bulletCooldown = 1000, //MS
		totalBullets = 0,
		bulletSpeed = 5,
		bulletColor = "#ff33cc",
		speed = 2,
		bulletSize = 4,
		maxSpeed = 4.5,
		alive = true,
		frozen = false,
		remove = false,
		faction = 0,
		drawImage = -1;
	e.onDeath = function(){
		remove = true;
	};

	e.GetHealth = function(){
		return health;
	};
	
	e.GetDrawImage = function(){
		return drawImage;
	};
	e.SetDrawImage = function(pDrawImage){
		drawImage = pDrawImage;
	};

	e.Draw = function(scene){
		var ctx = scene.GetCanvas().GetContext();
		if(drawImage != -1){
			ctx.drawImage(drawImage,this.GetX(),this.GetY(),this.GetWidth(),this.GetHeight());
			return;			
		}
		ctx.fillStyle = "rgba(255,179,0,1)";
		ctx.fillRect(this.GetX(),this.GetY(),this.GetWidth(),this.GetHeight());
	};

	e.GetMana = function(){
		return mana;
	};

	e.GetBulletColor = function(){
		return bulletColor;
	};

	e.GetDamage = function(){
		return damage;
	};

	e.GetBulletCooldown = function(){
		return bulletCooldown;
	};

	e.ModDelay = function(pDelay){
		if(Lynx.Constants.WAVE_MANAGER.GetDelay() == 1500){
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Lynx.Constants.MULTIPLIER;
			return;
		}
		Lynx.Constants.WAVE_MANAGER.ModDelay(pDelay);
	};

	e.GetTotalBullets = function(){
		return totalBullets; //Total number of bullets active
	};

	e.GetBulletSpeed = function(){
		return bulletSpeed;
	};

	e.GetSpeed = function(){
		return speed;
	};

	e.GetBulletSize = function(){
		return bulletSize;
	};

	e.GetTimedSpeed = function(){
		var ts = Math.floor((speed*Lynx.Time.GetDelta())/10);
		return ts;
	};

	e.IsAlive = function(){
		return alive;
	};

	e.IsFrozen = function(){
		return frozen;
	};

	e.GetFaction = function(){
		return faction;
	};

	e.SetHealth = function(pHealth){
		health = pHealth;
	};

	e.SetBulletColor = function(pColor){
		bulletColor = pColor;
	};

	e.SetBulletCooldown = function(pCooldown){
		bulletCooldown = pCooldown;
	};

	e.SetBulletSize = function(pSize){
		bulletSize = pSize;
	};

	e.ModBulletCooldown = function(pMod){
		bulletCooldown = bulletCooldown + pMod;
		if(bulletCooldown < 5){
			bulletCooldown = 5;
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Lynx.Constants.MULTIPLIER;
		};
	};

	e.SetMaxMana = function(pMaxMana){
		maxMana = pMaxMana;
	};

	e.SetMaxDamage = function(pMaxDamage){
		maxDamage = pMaxDamage;
	};

	e.SetMaxSpeed = function(pMaxSpeed){
		maxSpeed = pMaxSpeed;
	};


	e.Hurt = function(pHealthMod){
		health = health - pHealthMod;
		if(health <= 0){
			this.Kill();
		}
	};

	e.SetMana = function(pMana){
		mana = pMana;
	};

	e.UseMana = function(pManaCost){
		mana = mana - pManaCost;
		if(mana > maxMana){
			mana = maxMana;
		}
	};

	e.SetDamage = function(pDamage){
		damage = pDamage;
	};

	e.ModDamage = function(pDamageMod){
		damage = damage + pDamageMod;
		if(damage > maxDamage){
			damage = maxDamage;
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Lynx.Constants.MULTIPLIER;
		}
	};

	e.SetMaxBullets = function(pMaxBullets){
		maxBullets = pMaxBullets;
	};

	e.SetBulletSpeed = function(pSpeed){
		bulletSpeed = pSpeed;
	};

	e.ModBulletSpeed = function(pSpeedMod){
		bulletSpeed = bulletSpeed + pSpeedMod;
		if(bulletSpeed > 8){
			bulletSpeed = 8;
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Lynx.Constants.MULTIPLIER;
		}
	};

	e.SetSpeed = function(pSpeed){
		speed = pSpeed;
		if(speed > maxSpeed){
			speed = maxSpeed;
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Lynx.Constants.MULTIPLIER;
		}
	};

	e.ModSpeed = function(pSpeedMod){
		speed = speed + pSpeedMod;
		if(speed > maxSpeed){
			speed = maxSpeed;
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Lynx.Constants.MULTIPLIER;
		}
	};

	e.Kill = function(){
		alive = false;
		this.onDeath();
	};

	e.Revive = function(){
		alive = true;
	};

	e.Freeze = function(){
		frozen = true;
	};

	e.Thaw = function(){
		frozen = false;
	};

	e.Remove = function(){
		remove = true;
	};

	e.SetFaction = function(pFaction){
		faction = pFaction;
	};

	//Methods:
	e.Move = function(pX,pY){
			this.SetX(this.GetX() + pX);
			this.SetY(this.GetY() + pY);
		//TODO: Pathfinding
	};

	e.Shoot = function(pX,pY){
		if(Date.now() - lastShot > bulletCooldown){
			var dX = pX - (this.GetX() + this.GetWidth()/2);
			var dY = pY - (this.GetY() + this.GetHeight()/2);

			var mag = Math.sqrt(dX*dX + dY*dY);			
			var b = new Bullet(this.GetX()+25,this.GetY()+25,mag,dX,dY);
			b.SetSpeed(bulletSpeed);
			b.SetFrom(this);
			b.onDestroy = function(){
				totalBullets = totalBullets -1;
			};
			Lynx.Game.GetCurrentScene().AddObject(b);
			lastShot = Date.now();
			totalBullets++;
		}
	};

	e.RemoveObject = function(){
		if(remove){
			var index = Lynx.Game.GetCurrentScene().GetIndex(this);
			if(index != -1)
				Lynx.Game.GetCurrentScene().RemoveObject(index)
		}
	};

	e.WillRemove = function(){
		return remove;
	};

	e.Update = function(){
		if(health <= 0){
			this.Kill();
		}
	};


	return e;
};