//Main game File
function start(){
	var tc = document.getElementById("game-canvas");
	tc.width = window.innerWidth;
	tc.height = window.innerHeight;
	tc.oncontextmenu = function(){
		return false;
	};

	//Proto Functions:
	protoTime();
	protoIO();
	//End Protos.

	//Start object store:
	Lynx.Constants = {};
	Lynx.Constants.CURRENT_STATE = "loading";
	Lynx.Constants.GAMEOVER = function(){
		Lynx.Game.ChangeScene(scene_gameOver);
	};
	Lynx.Constants.PLAYER = new Player();
	Lynx.Constants.WAVE_MANAGER = WaveManager;
	Lynx.Constants.CURRENT_SCORE = 0;
	Lynx.Constants.HIGH_SCORE = 100;
	Lynx.Constants.STARTING_HEALTH = 50; //Easy Mode Below
	Lynx.Constants.STARTING_LEVEL = 0;
	Lynx.Constants.STARTING_MANA = 20;
	Lynx.Constants.DROP_MOD = 1.25;
	Lynx.Constants.STARTING_BSPEED = 600; //Bullet Cooldown
	Lynx.Constants.STARTING_BDAMAGE = 2;
	Lynx.Constants.MULTIPLIER = 1;
	Lynx.Constants.MODE = "Easy";
	Lynx.Constants.PAUSE = function(){
		Lynx.Time.Pause();
		Lynx.Constants.CURRENT_STATE = "paused";
	};
	Lynx.Constants.RESUME = function(){
		Lynx.Time.Reset();
		Lynx.Time.Resume();
		Lynx.Constants.CURRENT_STATE = "playing";
	};


	//DEVELOPER:
	Lynx.Settings.EnableDeveloperTools = false;
	Lynx.Settings.LoggerLevel = Lynx.LogLevel.FATAL_ERROR;

	//Load Assets
	Lynx.AssetManager.PutAsset("splashScreen",Lynx.AssetType.IMAGE,"assets/splashscreen.png");
	Lynx.AssetManager.PutAsset("logo",Lynx.AssetType.IMAGE,"assets/logo.png");
	Lynx.AssetManager.PutAsset("roboNoob",Lynx.AssetType.IMAGE,"assets/roboNoob.png");
	Lynx.AssetManager.PutAsset("roboScrub",Lynx.AssetType.IMAGE,"assets/roboScrub.png");
	Lynx.AssetManager.PutAsset("roboSoldier",Lynx.AssetType.IMAGE,"assets/roboSoldier.png");
	Lynx.AssetManager.PutAsset("roboCaptain",Lynx.AssetType.IMAGE,"assets/roboCaptain.png");
	Lynx.AssetManager.PutAsset("roboBro",Lynx.AssetType.IMAGE,"assets/roboBro.png");
	Lynx.AssetManager.PutAsset("roboSniper",Lynx.AssetType.IMAGE,"assets/roboSniper.png");
	Lynx.AssetManager.PutAsset("roboBasher",Lynx.AssetType.IMAGE,"assets/roboBasher.png");
	Lynx.AssetManager.PutAsset("roboMachiner",Lynx.AssetType.IMAGE,"assets/roboMachiner.png");
	Lynx.AssetManager.PutAsset("roboThug",Lynx.AssetType.IMAGE,"assets/roboThug.png");

	
	//Load Enemies
	WaveManager.AddEnemy(1,enemy_roboNoob,1);
	WaveManager.AddEnemy(4,enemy_roboScrub,3);
	WaveManager.AddEnemy(8,enemy_roboSoldier,5);
	WaveManager.AddEnemy(10,enemy_roboCaptain,6);
	WaveManager.AddEnemy(15,enemy_roboBro,8);
	WaveManager.AddEnemy(20,enemy_roboSniper,10);
	WaveManager.AddEnemy(30,enemy_roboBasher,12);
	WaveManager.AddEnemy(40,enemy_roboMachina,13);
	//End Enemies

	//Start Bosses
	WaveManager.AddBoss(50,boss_roboThug);
	//End Bosses

	//Set Preload Callback
	Lynx.Game.onready = function(){
		//Main Scene Event Functions
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.W,Lynx.IO.EventType.HOLD,function(){
			var player = Lynx.Constants.PLAYER;
			if(Lynx.Game.GetCurrentScene().GetName() == "Main" && player.GetY() >= 0){
				player.Move(0,0-player.GetTimedSpeed());
			}
		});
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.S,Lynx.IO.EventType.HOLD,function(){
			var player = Lynx.Constants.PLAYER;
			if(Lynx.Game.GetCurrentScene().GetName() == "Main" && player.GetY() + player.GetHeight() <= Lynx.Game.GetScreenHeight()){
				player.Move(0,player.GetTimedSpeed());
			}
		});
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.A,Lynx.IO.EventType.HOLD,function(){
			var player = Lynx.Constants.PLAYER;
			if(Lynx.Game.GetCurrentScene().GetName() == "Main" && player.GetX() >= 0){
				player.Move(0-player.GetTimedSpeed(),0);
			}
		});
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.D,Lynx.IO.EventType.HOLD,function(){
			var player = Lynx.Constants.PLAYER;
			if(Lynx.Game.GetCurrentScene().GetName() == "Main" && player.GetX() + player.GetWidth() <= Lynx.Game.GetScreenWidth()){
				player.Move(player.GetTimedSpeed(),0);
			}
		});
		Lynx.IO.Mouse.RegisterEvent("click",function(){
			var player = Lynx.Constants.PLAYER;
			if(Lynx.Game.GetCurrentScene().GetName() == "Main"){
				player.Shoot(Lynx.IO.Mouse.GetX(),Lynx.IO.Mouse.GetY());
			}
		});
		//Gameover Scene Event Functions
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.SPACE,Lynx.IO.EventType.DOWN,function(){
			if(Lynx.Game.GetCurrentScene().GetName() == "Gameover"){
				Lynx.Game.ChangeScene(scene_gameScene);
			}
			if(Lynx.Game.GetCurrentScene().GetName() == "Main"){
				if(Lynx.Constants.CURRENT_STATE == "playing"){
					Lynx.Constants.WAVE_MANAGER.ForceNextWave();
				}
				if(Lynx.Constants.CURRENT_STATE == "paused"){
					Lynx.Constants.RESUME();
				}
			}
		});
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.Y,Lynx.IO.EventType.DOWN,function(){
			if(Lynx.Game.GetCurrentScene().GetName() == "Main"){
				if(Lynx.Constants.CURRENT_STATE == "playing"){
					Lynx.Constants.PAUSE();
					return;
				}
				console.log(Lynx.Constants.CURRENT_STATE);
			}
		});
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.SHIFT,Lynx.IO.EventType.DOWN,function(){
			if(Lynx.Game.GetCurrentScene().GetName() == "Gameover"){
				Lynx.Game.ChangeScene(scene_menuScene);
			}
			if(Lynx.Game.GetCurrentScene().GetName() == "Main"){
				if(Lynx.Constants.PLAYER.GetMana() >= 50){
					Lynx.Constants.WAVE_MANAGER.KillAllEnemies();
					Lynx.Constants.PLAYER.UseMana(50);
				}
			}
		});
		Lynx.IO.RegisterEvent(Lynx.IO.KeyCode.F,Lynx.IO.EventType.DOWN,function(){
			if(Lynx.Game.GetCurrentScene().GetName() == "Main"){
				var healRate = 0;
				healRate = Math.floor(Lynx.Constants.PLAYER.GetMana()/2);
				var diff = Lynx.Constants.PLAYER.GetMaxHealth() - Lynx.Constants.PLAYER.GetHealth();
				if(healRate > diff){
					healRate = diff;
				}
				Lynx.Constants.PLAYER.Heal(healRate);
				Lynx.Constants.PLAYER.UseMana(healRate*2);
			}
		});
		//Main Menu Scene Event Functions
		Lynx.IO.Mouse.RegisterEvent("click",function(){
			if(Lynx.Game.GetCurrentScene().GetName() == "Menu"){
				Lynx.Game.GetCurrentScene().ParseClick();
			}
		});
	};

	window.onbeforeunload = function(pEvent) {
		pEvent = pEvent || window.event;
		if(Lynx.Constants.CURRENT_STATE == "playing" || Lynx.Constants.CURRENT_STATE == "paused"){
				Lynx.Constants.PAUSE();
			if(pEvent){
				pEvent.returnValue = "Are you sure you want to leave this page? You will lose your game data.";
			}
		return "Are you sure you want to leave this page? You will lose your game data.";
		}
	};


	Lynx.Game.Run("FCH - LD27","game-canvas",scene_preloadScene);
};

window.addEventListener("load",start,false);