function protoIO(){
	var IO = Lynx.IO;

	Lynx.IO.KeyCode.W = 87;
	Lynx.IO.KeyCode.A = 65;
	Lynx.IO.KeyCode.S = 83;
	Lynx.IO.KeyCode.D = 68;
	Lynx.IO.KeyCode.F = 70;
	Lynx.IO.KeyCode.Y = 89;

	//We need to proto the IO to allow mouse input.
	//But You're feeling a little tired so we'll do that tomorrow and just focus on movement
	IO.Mouse = (function(){
		var that = {};
		
		var x = 0,
			y = 0,
			mouseOverEvents = [],
			mouseClickEvents = [];

		that.GetX = function(){
			return x;
		};

		that.GetY = function(){
			return y;
		};

		that.RegisterEvent = function(pType,pCallback){
			//The "Callback" is actually an event object with the callback in it. Test for X/Y
			if(pType == "over"){
				mouseOverEvents.push(pCallback);
			}
			if(pType == "click"){
				mouseClickEvents.push(pCallback);
			}
		};

		that.CreateEvent = function(pRect,pCallback){
			return {
				rect: pRect,
				callback: pCallback
			};
		};

		that.MouseClickListener = function(pEvent){
			for(var i in mouseClickEvents){
				var cEvent = mouseClickEvents[i];
				cEvent();
			}
			pEvent.preventDefault();
		};

		that.MouseMoveListener = function(pEvent){
			x = pEvent.clientX;
			y = pEvent.clientY;
			//We'll call the function loop in the update event for mouseovers
		};

		that.CheckMouseEvents = function(){
			//Called every update
			for(var i in mouseOverEvents){
				if((x > rect.GetX() && x < rect.GetX() + rect.GetWidth()) && (y > rect.GetY() && y < rect.GetY() + rect.GetHeight()))
					mouseOverEvents[i].callback();
			}
		};

		return that;
	})();


	window.addEventListener("mousemove",IO.Mouse.MouseMoveListener,false);
	window.addEventListener("mousedown",IO.Mouse.MouseClickListener,false);

};
