function Player(){
	var p = new Entity("player",window.innerWidth/2-25,window.innerHeight/2-25,50,50);
	p.SetSpeed(2.5);
	p.SetBulletSize(7);
	p.SetBulletColor("rgba(0,0,0,1)");
	var maxHealth = 20;

	p.ConsumePowerup = function(pObject){
		if(pObject.GetType() == PowerupType.MOVE_SPEED){
			this.ModSpeed(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.TIME_EXTEND){
			this.ModDelay(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.BULLET_SPEED){
			this.ModBulletSpeed(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.BULLET_POWER){
			this.ModDamage(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.BULLET_CD){
			this.ModBulletCooldown(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.LIFE_UP){
			this.Heal(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.MAXLIFE_UP){
			this.ModMaxHealth(pObject.GetMod());
			this.Heal(pObject.GetMod());
		}
		if(pObject.GetType() == PowerupType.MANA_UP){
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + pObject.GetMod()*Lynx.Constants.MULTIPLIER;
			this.UseMana(-pObject.GetMod());
		}
		//Remove object
		pObject.Consumed();
	};

	p.Draw = function(scene){
		if(Lynx.Game.GetCurrentScene().GetName() == "Main"){
			var ctx = scene.GetCanvas().GetContext();
			ctx.fillStyle = "rgba(0,0,0,1)";
			ctx.fillRect(this.GetX(),this.GetY(),this.GetWidth(),this.GetHeight());
		}else{
			Lynx.Logger.Log(Lynx.Constants.CURRENT_STATE);
		}
	};

	p.RemoveObject = function(){
		if(this.WillRemove()){
			if(this.Alive){
				Lynx.Logger.Log("Attempting to remove player while alive!!!")
				return;
			}
			var index = Lynx.Game.GetCurrentScene().GetIndex(this);
			if(index != -1)
				Lynx.Game.GetCurrentScene().RemoveObject(index)
		}
	};
	p.Heal = function(factor){
		this.Hurt(-factor);
		if(this.GetHealth() > maxHealth){
			this.SetHealth(maxHealth);
		}
	};

	p.GetMaxHealth = function(){
		return maxHealth;
	};
	
	p.ModMaxHealth = function(pMHPMod){
		if(maxHealth < 255){
			maxHealth = maxHealth + pMHPMod;
			if(maxHealth > 255){
				maxHealth = 255;
			}
		}else{
			Lynx.Constants.CURRENT_SCORE = 3*Lynx.Constants.MULTIPLIER;
		}
	};

	p.SetMaxHealth = function(pMaxHealth){
		maxHealth = pMaxHealth;
	};
	
	p.onDeath = function(){
		this.Remove();
		Lynx.Constants.CURRENT_STATE = "gameOver";
	};

	p.SetHealth(maxHealth);

	return p;
};