function Powerup(pX,pY,pType,pMod){
	var p = new Lynx.GameObject("powerup_"+pType+pMod+(Math.floor(Math.random()*10)+"_"+pX+pY),pX,pY,50,50);
	var type = pType,
		mod = pMod,
		consumed = false,
		fillColor = ("rgba(0,179,255,1)"),
		strokeColor = ("rgba(0,0,0,0.7)"),
		fillText = "MANA",
		oper = "";
/*
	BULLET_SPEED: 1,
	BULLET_POWER: 2,
	BULLET_MAX: 3,
	TIME_EXTEND: 4,
	LIFE_UP: 5,
	MANA_UP: 6,
	MAXLIFE_UP: 7,
	BULLET_CD: 8,
//SPECIAL POWERUPS
	KITTEN: 20
	*/

	if(mod > 0)
		oper = "+";

	if(type == PowerupType.MOVE_SPEED){
		fillText = "SPEED";
		fillColor = "rgba(196,123,155,1)";
	}
	if(type == PowerupType.BULLET_SPEED){
		fillText = "BSPEED";
		fillColor = "rgba(0,84,166,1)";
	}
	if(type == PowerupType.BULLET_POWER){
		fillText = "DMG";
		fillColor = "rgba(158,0,57,1)";
	}
	if(type == PowerupType.TIME_EXTEND){
		fillText = "TIME";
		fillColor = "rgba(96,96,96,1)";
	}
	if(type == PowerupType.LIFE_UP){
		fillText = "HP";
		fillColor = "rgba(246,150,121,1)";
	}
	if(type == PowerupType.MAXLIFE_UP){
		fillText = "MAXHP";
		fillColor = "rgba(158,11,15,1)";
	}
	if(type == PowerupType.BULLET_CD){
		fillText = "CD";
		fillColor = "rgba(25,123,48,1)";
	}

	p.GetType = function(){
		return type;
	};

	p.GetMod = function(){
		return mod;
	};

	p.SetType = function(pType){
		type = pType;
	};

	p.SetMod = function(pMod){
		mod = pMod;
	};

	p.Draw = function(scene){
		var ctx = scene.GetCanvas().GetContext();
		ctx.fillStyle = fillColor;
		ctx.beginPath();
		var xPos = Math.floor((this.GetX()+this.GetWidth()/2));
		var yPos = Math.floor((this.GetY()+this.GetHeight()/2));
		ctx.arc(xPos,
				yPos,
				Math.floor(this.GetWidth()/2),
				0,
				2*Math.PI,
				false);
		ctx.fill()
		ctx.lineWidth = 2;
		ctx.strokeStyle = strokeColor;
		ctx.stroke();
		ctx.fillStyle = "rgba(255,255,255,0.9)";
		ctx.font = "10px 'Press Start 2P'";
		ctx.textAlign = "center";
		ctx.fillText(oper+this.GetMod(),xPos,yPos,this.GetWidth());
		yPos = yPos + 10;
		ctx.font = "10px 'Press Start 2P'";
		ctx.fillText(fillText,xPos,yPos,this.GetWidth());
	};

	p.Consumed = function(){
		consumed = true;
	};

	p.Update = function(){	//Have to remove in update rather than coll check otherwise engine breaks.
		if(consumed){
			var index = Lynx.Game.GetCurrentScene().GetIndex(this);
			if(index != -1){
				Lynx.Game.GetCurrentScene().RemoveObject(index);
			}else{
				Lynx.Logger.Log("Failed to remove object from Scene...",Lynx.LogLevel.DEV);
			}
		}
	};

	p.oncollision = function(pEvent){
		if(pEvent.collidingObject.GetName() == "player"){
			pEvent.collidingObject.ConsumePowerup(this);
			Lynx.Logger.Log("Powerup '"+this.GetName()+"' Consumed.",Lynx.LogLevel.DEV);
		}
		pEvent.resolved = true;
	};

	p.SetCollisions(true);


	return p;
};