function protoTime(){
	var time = Lynx.Time;
	time._eventCallbacks = [];
	time._specialCallbacks = [];

	var currentlyPaused = false;

	time.ScheduleEvent = function(pDelay,pCallback,pSpecial){
		if(typeof pSpecial == 'undefined')
			pSpecial = false;

		var eventObject = {
				start_time: Date.now(),
				delay: pDelay,
				callback: pCallback
			}
		if(pSpecial){
			time._specialCallbacks.push(eventObject);
		}else{
			time._eventCallbacks.push(eventObject);
		}
	};

	time.ClearEvents = function(){
		time._eventCallbacks = [];
	};
	time.ClearSpecialEvents = function(){
		time._specialCallbacks = [];
	};
	time.Pause = function(){
		currentlyPaused = true;
	};

	time.Resume = function(){
		currentlyPaused = false;
	};

	time.OldTick = time.Tick;

	time.ModEventDelay = function(pDelay){
		for(var i in time._eventCallbacks){
			var cb = time._eventCallbacks[i];
			cb.delay = cb.delay + pDelay;
			if(cb.delay > 15000){
				cb.delay = 15000;
			}
		}
	};

	time.Tick = function(){
		time.OldTick();
		if(currentlyPaused){
			var offset = this.GetDelta();
			for(var i in time._specialCallbacks){
				var cEvent = time._specialCallbacks[i];
				cEvent.delay = cEvent.delay + offset;
			}
			for(var i in time._eventCallbacks){
				var cEvent = time._eventCallbacks[i];
				cEvent.delay = cEvent.delay + offset;
			}
			return;
		}
		for(var i in time._specialCallbacks){
			var cEvent = time._specialCallbacks[i];
			var totalDelay = Date.now() - cEvent.start_time;
			if(cEvent.delay <= totalDelay){
				cEvent.callback();
				time._specialCallbacks.splice(i,1);
			}
		}
		for(var i in time._eventCallbacks){
			var cEvent = time._eventCallbacks[i];
			var totalDelay = Date.now() - cEvent.start_time;
			if(cEvent.delay <= totalDelay){
				cEvent.callback();
				time._eventCallbacks.splice(i,1);
			}
		}
	};
};