var WaveManager = (function(){
	var that = {};
	
	var enemies = [],
		enemyLevels = [],
		enemyCost = [],
		bosses = [],
		lastWave = 0,
		currentLevel = 0,
		delay = 10000,
		timeLeft = 0;

	that.AddEnemy = function(pLevel,pCallback,pCost){
		//pLevel is minimum level for the enemy to appear
		enemyLevels.push(pLevel);
		enemies.push(pCallback);
		enemyCost.push(pCost);
	};

	that.AddBoss = function(pLevel,pCallback){
		bosses[pLevel] = pCallback;
	};

	that.ForceNextWave = function(){
		if(Date.now() - lastWave > 300){
			Lynx.Constants.CURRENT_SCORE = Lynx.Constants.CURRENT_SCORE + Math.floor(this.GetNextWaveTime()*this.GetCurrentLevel()/7)*Lynx.Constants.MULTIPLIER;
			Lynx.Time.ClearEvents();
			that.NextWave(Lynx.Game.GetCurrentScene());
		}
	};

	that.GetCurrentLevel = function(){
		return currentLevel;
	};

	that.GetDelay = function(){
		return delay;
	};

	that.SetCurrentLevel = function(pLevel){
		currentLevel = pLevel;
	};

	that.SetDelay = function(pDelay){
		delay = pDelay;
	};

	that.KillAllEnemies = function(){
		//Prevents drops and kills all enemies
		var gos = Lynx.Game.GetCurrentScene().GetObjects();
		for(var i in gos){
			if(typeof gos[i].PreventDrops != 'undefined'){
				gos[i].PreventDrops();
				gos[i].Kill();
			}
		}
	};

	that.NextWave = function(scene){
		if(typeof scene == 'undefined')
			scene = Lynx.Game.GetCurrentScene();
		if(Lynx.Constants.CURRENT_STATE == "playing"){
			forcing = false;
			currentLevel++;
			if(typeof bosses[currentLevel] == 'undefined'){
				var currency = currentLevel;
				var enemyCount = 0;
				while(currency > 0){
					var cIndex = Math.floor(Math.random()*enemies.length);
					if(currentLevel >= enemyLevels[cIndex] && currency >= enemyCost[cIndex]){
						var enemyObject = new enemies[cIndex]("Wave_"+currentLevel+"_"+enemyCount);
						scene.AddObject(enemyObject);
						currency = currency - enemyCost[cIndex];
						enemyCount++;
					}
					if(enemyLevels.length < 1){
						currency = 0;
					}
				}
				lastWave = Date.now();
				Lynx.Time.ScheduleEvent(delay,that.NextWave);
			}else{
				var bossObj = new bosses[currentLevel]("Wave_"+currentLevel+"_BOSS");
				scene.AddObject(bossObj);
				bossObj.onSpawn();
				lastWave = Date.now();
				Lynx.Time.ScheduleEvent(delay*2,that.NextWave);
			}
		}
	};

	that.GetNextWaveTime = function(){

		if(Lynx.Constants.CURRENT_STATE == "playing"){
			if(typeof bosses[currentLevel] != 'undefined'){
				timeLeft = (delay*2)/1000 - (Date.now() - lastWave)/1000;
			}else{
				timeLeft = delay/1000 - (Date.now() - lastWave)/1000;
			}
		}else{
			lastWave = lastWave + Lynx.Time.GetDelta();
		}
		return timeLeft.toFixed(1);
	};

	that.ModDelay = function(pDelayMod){
		delay = delay + pDelayMod;
		if(delay > 15000){
			delay = 15000;
		}
		Lynx.Time.ModEventDelay(pDelayMod);
	};

	that.Reset = function(){
		delay = 10000;
		currentLevel = Lynx.Constants.STARTING_LEVEL;
	};



	return that;	
})();