scene_gameScene = (function(){
	var gameScene = new Lynx.Scene("Main");
	gameScene.Open = function(){
		this.Clear();
		Lynx.Constants.CURRENT_STATE = "playing";
		Lynx.Constants.CURRENT_SCORE = 0;
		var player = new Player();
		gameScene.AddObject(player);
		Lynx.Constants.PLAYER = player;
		player.SetMaxHealth(Lynx.Constants.STARTING_HEALTH);
		player.Heal(Lynx.Constants.STARTING_HEALTH);
		player.SetBulletCooldown(Lynx.Constants.STARTING_BSPEED);
		player.SetDamage(Lynx.Constants.STARTING_BDAMAGE);
		Lynx.Constants.WAVE_MANAGER.Reset();
		Lynx.Constants.WAVE_MANAGER.SetCurrentLevel(Lynx.Constants.STARTING_LEVEL);
		Lynx.Constants.WAVE_MANAGER.NextWave(this);
	};

	gameScene.Update = function(){
		if(Lynx.Constants.CURRENT_STATE == "playing"){
			var gos = this.GetObjects();
			for(var i in gos){
				gos[i].Update();
			}
		}
		if(Lynx.Constants.CURRENT_STATE == "gameOver" || !Lynx.Constants.PLAYER.IsAlive())
			Lynx.Constants.GAMEOVER();
	};

	var oldDraw = gameScene.Draw;

	gameScene.Draw = function(){
		oldDraw();
		var player = Lynx.Constants.PLAYER;
		//UI Goes Here.
		var ctx = this.GetCanvas().GetContext();
		ctx.textAlign = "left";
		ctx.fillStyle = "rgba(0,0,0,1)";
		ctx.font = "12px 'Press Start 2P'";
		var bottom = this.GetCanvas().GetHeight();
		ctx.fillText("Health: "+player.GetHealth()+"/"+player.GetMaxHealth(),5,50);
		ctx.fillText("Mana: "+player.GetMana(),5,70);
		ctx.fillText("Speed: "+ player.GetSpeed(),5,90);
		ctx.fillText("Damage: "+ player.GetDamage(),5,110);
		ctx.fillText("Cooldown: "+player.GetBulletCooldown()+"ms",5,130);
		ctx.fillText("Score: "+Lynx.Constants.CURRENT_SCORE,5,150);
		ctx.fillText("Level: "+WaveManager.GetCurrentLevel(),5,170)
		ctx.fillText("Next Wave in "+WaveManager.GetNextWaveTime()+"s",this.GetCanvas().GetWidth()-225,bottom-15);
		if(Lynx.Constants.CURRENT_STATE == "paused"){
			ctx.fillStyle = "rgba(0,0,0,0.7)";
			ctx.fillRect(0,0,this.GetCanvas().GetWidth(),this.GetCanvas().GetHeight());
			ctx.font = "25px 'Press Start 2P'";
			var fontX = Math.floor(this.GetCanvas().GetWidth()/2 - ctx.measureText("Game Paused").width/2);
			var fontY = 100;
			ctx.fillStyle = "rgba(255,255,255,1)";
			ctx.fillText("Game Paused",fontX,fontY);
			fontY = fontY + 45;
			ctx.font = "14px 'Press Start 2P'";
			fontX = Math.floor(this.GetCanvas().GetWidth()/2 - ctx.measureText("[Press space to resume]").width/2);
			ctx.fillText("[Press space to resume]",fontX,fontY);
		}
	};

	return gameScene;
})();