var scene_menuScene = (function(){
	var menu = new Lynx.Scene("Menu");


	function Screen(pName){
		var that = {};

		var name = pName,
			menuObjects = [];

		that.GetName = function(){
			return name;
		};

		that.AddMenuObject = function(pText,pFontSize,pCallback){
			var menuObj = {
				displayText: pText,
				fontSize: pFontSize,
				callback: pCallback,
				x: 0,
				y: 0,
				width: 0,
				height: 0,
				Draw: function(ctx,xPos,yPos){
					ctx.font = this.fontSize+"px 'Press Start 2P'";
					var met = ctx.measureText(this.displayText);
					this.width = met.width;
					if(this.height == 0)
						this.height = this.fontSize;
					this.x = Math.floor(xPos-met.width/2);
					this.y = yPos-this.height;
					if(this.displayText == "LOGO"){
						ctx.drawImage(Lynx.AssetManager.GetImage("logo").GetObject(),xPos - 299, yPos -40);
					}else{
						ctx.fillText(this.displayText,xPos,yPos);
					}
				}
			};

			menuObjects.push(menuObj);
		};

		that.CheckMouseEvents = function(){
			var mouseX = Lynx.IO.Mouse.GetX();
			var mouseY = Lynx.IO.Mouse.GetY();
			for(var i in menuObjects){
				var co = menuObjects[i];
				if(co.x <= mouseX &&
					co.y <= mouseY &&
					co.x+(co.width) >= mouseX &&
					co.y+(co.height) >= mouseY){
						co.callback();
					}
			}
		};

		that.Draw = function(scene){
			var ctx = scene.GetCanvas().GetContext();
			ctx.clearRect(0,0,scene.GetCanvas().GetWidth(),scene.GetCanvas().GetHeight());
			var xPos = Math.floor(scene.GetCanvas().GetWidth()/2);
			var yPos = 0;
			ctx.fillStyle = "rgba(0,0,0,1)";
			ctx.textAlign = "center";
			for(var i in menuObjects){
				var co = menuObjects[i];
				yPos = yPos + co.height + 1;
				co.Draw(ctx,xPos,yPos);
			}
		};

		that.Open = function(){
			//Open Goes here if needed for some reason?
		};

		return that;
	};
	menu.Open = function(){
		//Main Menu
			var mainScreen = new Screen("screen_menu");
			mainScreen.AddMenuObject("",40,function(){
				return;
			});
			mainScreen.AddMenuObject("LOGO",40,function(){
				return;
			});
			mainScreen.AddMenuObject("",40,function(){
				return;
			});
			mainScreen.AddMenuObject("Play",30, function(){
				menu.ChangeScreen("level_select");
			});
			mainScreen.AddMenuObject("",30,function(){
				return;
			});
			mainScreen.AddMenuObject("How To",30, function(){
				menu.ChangeScreen("how_to");
			});
			mainScreen.AddMenuObject("",30,function(){
				return;
			});
			mainScreen.AddMenuObject("Credits",30, function(){
				menu.ChangeScreen("credits");
			});
			this.AddScreen(mainScreen);
		//Level Select
			var levelScreen = new Screen("level_select");
				levelScreen.AddMenuObject("Select Difficulty",40,function(){
					return;
				});
				levelScreen.AddMenuObject("",10,function(){
					return;
				});
				levelScreen.AddMenuObject("Easy",25,function(){
				Lynx.Constants.STARTING_HEALTH = 50; //Easy Mode Below
				Lynx.Constants.STARTING_LEVEL = 0;	//CHANGE TO 0
				Lynx.Constants.STARTING_MANA = 20;
				Lynx.Constants.STARTING_BSPEED = 750; //CHANGE TO 750
				Lynx.Constants.STARTING_BDAMAGE = 1; //CHANGE TO 1
				Lynx.Constants.MULTIPLIER = 1;
				Lynx.Constants.MODE = "Easy";
				Lynx.Constants.DROP_MOD = 1.25;
				Lynx.Game.ChangeScene(scene_gameScene);
			})
			levelScreen.AddMenuObject("",5,function(){
				return;
			});
			levelScreen.AddMenuObject("Start with 50HP, fast bullets and 20 mana.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("More Drops. 1x score multiplier.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("",15,function(){
				return;
			});			
			levelScreen.AddMenuObject("Normal",25,function(){
				Lynx.Constants.STARTING_HEALTH = 20; //Easy Mode Below
				Lynx.Constants.STARTING_LEVEL = 0;
				Lynx.Constants.STARTING_MANA = 0;
				Lynx.Constants.STARTING_BSPEED = 1000; //Bullet Cooldown
				Lynx.Constants.DROP_MOD = 1;
				Lynx.Constants.STARTING_BDAMAGE = 1;
				Lynx.Constants.MULTIPLIER = 3;
				Lynx.Constants.MODE = "Normal";
				Lynx.Game.ChangeScene(scene_gameScene);
			})
			levelScreen.AddMenuObject("",5,function(){
				return;
			});
			levelScreen.AddMenuObject("Start with 20HP and normal bullets.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("Normal Drops. 3x score multiplier.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("",15,function(){
				return;
			});
			levelScreen.AddMenuObject("Hard",25,function(){
				Lynx.Constants.STARTING_HEALTH = 15; //Easy Mode Below
				Lynx.Constants.STARTING_LEVEL = 0;	//Actually starts on 5
				Lynx.Constants.STARTING_MANA = 0;
				Lynx.Constants.DROP_MOD = 1;
				Lynx.Constants.STARTING_BSPEED = 1500; //Bullet Cooldown
				Lynx.Constants.STARTING_BDAMAGE = 1;
				Lynx.Constants.MULTIPLIER = 5;
				Lynx.Constants.MODE = "Hard";
				Lynx.Game.ChangeScene(scene_gameScene);
			})
			levelScreen.AddMenuObject("",5,function(){
				return;
			});
			levelScreen.AddMenuObject("Start with 15HP and slow bullets.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("Normal Drops. 5x score multiplier.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("",15,function(){
				return;
			});
			levelScreen.AddMenuObject("Insane",25,function(){
				if(Lynx.Constants.HIGH_SCORE < 2500){
					return;
				}
				Lynx.Constants.STARTING_HEALTH = 5; //Easy Mode Below
				Lynx.Constants.STARTING_LEVEL = 0;	//Actually starts on 5
				Lynx.Constants.STARTING_BSPEED = 2000; //Bullet Cooldown
				Lynx.Constants.STARTING_BDAMAGE = 1;
				Lynx.Constants.DROP_MOD = 0.75;
				Lynx.Constants.STARTING_MANA = 0;
				Lynx.Constants.MULTIPLIER = 10;
				Lynx.Constants.MODE = "Insane";
				Lynx.Game.ChangeScene(scene_gameScene);
			})
			levelScreen.AddMenuObject("",5,function(){
				return;
			});
			levelScreen.AddMenuObject("Start with 5HP and slowest bullets.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("Less Drops. 10x score multiplier.",15,function(){
				return;
			});
			levelScreen.AddMenuObject("",5,function(){
				return;
			})
			if(Lynx.Constants.HIGH_SCORE < 5000){
				levelScreen.AddMenuObject("[Currently Locked. Get 5000 points to Unlock]",10,function(){
					return;
				});				
			}
			levelScreen.AddMenuObject("",25,function(){
				return;
			});
			levelScreen.AddMenuObject("Back",25,function(){
				menu.ChangeScreen("screen_menu");
			});			
			this.AddScreen(levelScreen);
		//How To Screen
			var howScreen = new Screen("how_to");
			howScreen.AddMenuObject("How to Play",40,function(){
				return;
			});
			howScreen.AddMenuObject(" ",10,function(){
				return;
			});			
			howScreen.AddMenuObject("The robots are rebelling and you're trapped in",14,function(){
				return;
			});
			howScreen.AddMenuObject("a food court. What's worse is there's not even",14,function(){
				return;
			});
			howScreen.AddMenuObject("any food! You must stop them by destroying all",14,function(){
				return;
			});
			howScreen.AddMenuObject("robots and making friends with the local wildlife.",14,function(){
				return;
			});
			howScreen.AddMenuObject("How long will you last before your impending doom?",14,function(){
				return;
			});
			howScreen.AddMenuObject(" ",10,function(){
				return;
			});			
			howScreen.AddMenuObject("Controls:",20,function(){
				return;
			});
			howScreen.AddMenuObject("",10,function(){
				return;
			});
			howScreen.AddMenuObject("W: Move Up",14,function(){
				return;
			});
			howScreen.AddMenuObject("S: Move Down",14,function(){
				return;
			});
			howScreen.AddMenuObject("A: Move Left",14,function(){
				return;
			});
			howScreen.AddMenuObject("D: Move Right",14,function(){
				return;
			});
			howScreen.AddMenuObject("Mouse Click: Shoot a Bullet!",14,function(){
				return;
			});
			howScreen.AddMenuObject("Space: Spawn next",14,function(){
				return;
			});
			howScreen.AddMenuObject("Shift: Use 50 mana to kill all robots.",14,function(){
				return;
			});
			howScreen.AddMenuObject("F: Heal yourself [2 Mana per HP]",14,function(){
				return;
			});
			howScreen.AddMenuObject("Y: Pause Game",14,function(){
				return;
			});
			howScreen.AddMenuObject("",10,function(){
				return;
			});
			howScreen.AddMenuObject("Collect Mana and Powerups to get Stronger.",14,function(){
				return;
			});
			howScreen.A
			howScreen.AddMenuObject("",10,function(){
				return;
			});
			howScreen.AddMenuObject("Good Luck.",14,function(){
				return;
			});
			howScreen.AddMenuObject("",25,function(){
				return;
			});
			howScreen.AddMenuObject("Back",25,function(){
				menu.ChangeScreen("screen_menu");
			});
			this.AddScreen(howScreen);
		//Credits
			var creditScreen = new Screen("credits");
			creditScreen.AddMenuObject("Credits",40,function(){
				return;
			});
			creditScreen.AddMenuObject("",20,function(){
				return;
			});
			creditScreen.AddMenuObject("Code, art and game design were all done by",18,function(){
				window.open("http://cosrnos.com/");
			});
			creditScreen.AddMenuObject("Alex Roth (@cosrnos) for the Ludum Dare!",18,function(){
				window.open("http://cosrnos.com/")
			});
			creditScreen.AddMenuObject("",5,function(){
				return;
			});
			creditScreen.AddMenuObject("(clicky above!!!!)",12,function(){
				return;
			});
			creditScreen.AddMenuObject("",20,function(){
				return;
			});
			creditScreen.AddMenuObject("Special Thanks To:",20,function(){
				return;
			});
			creditScreen.AddMenuObject("",10,function(){
				return;
			});
			creditScreen.AddMenuObject("Kiango [Tumblr] - Beta Testing",12,function(){
				window.open("http://kiango.tumblr.com/");
			});
			creditScreen.AddMenuObject("eirstegalkin [Tumblr] - Beta Testing",12,function(){
				window.open("http://eirstegalkin.tumblr.com/");
			});
			creditScreen.AddMenuObject("breaking-brad [Tumblr] - Beta Testing",12,function(){
				window.open("http://breaking-brad.tumblr.com/");
			});
			creditScreen.AddMenuObject("Candycool - Beta Testing",12,function(){
				return;
			});
			creditScreen.AddMenuObject("tacospice [irc] - Beta Testing",12,function(){
				return;
			});
			creditScreen.AddMenuObject("The entire Ludum Dare Community & Administrators.",12,function(){
				window.open("http://ludumdare.com/compo");
			});
			creditScreen.AddMenuObject("And YOU!",14,function(){
				return;
			});
			creditScreen.AddMenuObject("",25,function(){
				return;
			});
			creditScreen.AddMenuObject("Back",25,function(){
				menu.ChangeScreen("screen_menu");
			});
			this.AddScreen(creditScreen);

		this.ChangeScreen("screen_menu");
	};
	var screens = [];
	var currentScreen = 0;

	menu.AddScreen = function(pScreen){
		screens[pScreen.GetName()] = pScreen;
	};

	menu.ChangeScreen = function(pScreenName){
		if(typeof screens[pScreenName] == 'undefined')
			return;

		currentScreen = pScreenName;
		screens[currentScreen].Open();
	};

	menu.GetCurrentScreen = function(){
		return currentScreen;
	};

	menu.Draw = function(){
		if(typeof screens[currentScreen] == 'undefined'){
			return;
		}
		screens[currentScreen].Draw(this);
	};

	menu.Update = function(){
		//TODO: Check for hover for clickables.
	};

	menu.End = function(){

	};

	menu.ParseClick = function(){
		if(typeof screens[currentScreen] == 'undefined')
			return;
		screens[currentScreen].CheckMouseEvents();
	};


	return menu;
})();